'=============================================================================
' 437-RTF                           1.002                          22. 9.2016
'=============================================================================
' Programm zur Umwandlung von Dateien der ASCII Zeichensatztabelle 437 in das
' Rich Text Format (RTF), um die Datei auch unter Windows drucken zu knnen.
'=============================================================================
' Bearbeitung:
' 27.12.2007 - 22. 9.2016 Norbert Sdland
'=============================================================================
DIM Quelle$
DIM Zwischenziel$
DIM Ziel$
DIM Position%
DIM EingabeDatei%
DIM AusgabeDatei%
DIM Zeile$
DIM Zaehler%
DIM Kopie$
DIM Zeichen$
DIM Kodierung$

IF ENVIRON$("ERSTENS") = "" THEN
  PRINT "Bitte starten Sie das Programm "; CHR$(34); "437-RTF.BAT"; CHR$(34);
  PRINT " mit den zugehrigen Argumenten."
ELSE
  Quelle$ = ENVIRON$("ERSTENS")
  Zwischenziel$ = ENVIRON$("ZWEITENS")
  IF Zwischenziel$ = "" THEN
    Zwischenziel$ = "437-RTF.ERG"
  END IF
  Ziel$ = ENVIRON$("DRITTENS")
  IF Ziel$ = "" THEN
    Ziel$ = Zwischenziel$
  END IF
  IF Quelle$ = Zwischenziel$ THEN
    PRINT "Quelle "; CHR$(34); Quelle$; CHR$(34); " und Zwischenziel ";
    PRINT CHR$(34); Zwischenziel$; CHR$(34); " sind identisch."
    PRINT "Das Programm wird abgebrochen."
  ELSEIF Quelle$ = Ziel$ THEN
    PRINT "Quelle "; CHR$(34); Quelle$; CHR$(34); " und Ziel ";
    PRINT CHR$(34); Ziel$; CHR$(34); " sind identisch."
    PRINT "Das Programm wird abgebrochen."
  ELSE
    Position% = INSTR(Ziel$, "\")
    WHILE Position% > 0
      Ziel$ = RIGHT$(Ziel$, LEN(Ziel$) - Position%)
      Position% = INSTR(Ziel$, "\")
    WEND

    EingabeDatei% = FREEFILE
    OPEN Quelle$ FOR INPUT AS #EingabeDatei%
      AusgabeDatei% = FREEFILE
      OPEN Zwischenziel$ FOR OUTPUT AS #AusgabeDatei%
        PRINT #AusgabeDatei%, "{\rtf1\deff0{\fonttbl";
        PRINT #AusgabeDatei%, "{\f0\fcharset0 Courier New;}";
        PRINT #AusgabeDatei%, "{\f1\fcharset161\fprq1 Courier New Greek;}";
        PRINT #AusgabeDatei%, "{\f2\fcharset204\fprq1 Courier New Cyr;}";
        PRINT #AusgabeDatei%, "{\f3\fcharset0 Times New Roman;}";
        PRINT #AusgabeDatei%, "{\f4\fcharset161\fprq1 Times New Roman";
        PRINT #AusgabeDatei%, " Greek;}";
        PRINT #AusgabeDatei%, "{\f5\fcharset204\fprq1 Times New Roman Cyr;}}"
        PRINT #AusgabeDatei%, "\margl1134\margr1134\margt1417\margb1134"
        PRINT #AusgabeDatei%, "\viewkind1\uc1"
        PRINT #AusgabeDatei%, "{\headerl \f3 ";
        PRINT #AusgabeDatei%, "\widctlpar\brdrb\brdrs\brdrw30\brsp20 ";
        PRINT #AusgabeDatei%, "\tqc\tx5000\tqr\tx10000\adjustright";
        PRINT #AusgabeDatei%, "{Seite }";
        PRINT #AusgabeDatei%, "{\field{\*\fldinst{ PAGE }}}{ / }";
        PRINT #AusgabeDatei%, "{\field{\*\fldinst{ NUMPAGES }}}"
        PRINT #AusgabeDatei%, "{\tab \'a9 Norbert S\'fcdland\tab }"
        PRINT #AusgabeDatei%, "{\field{\*\fldinst{ FILENAME }}";
        PRINT #AusgabeDatei%, "{\fldrslt{"; Ziel$; "}}}";
        PRINT #AusgabeDatei%, "{\par }}"
        PRINT #AusgabeDatei%, "{\headerr \f3 ";
        PRINT #AusgabeDatei%, "\widctlpar\brdrb\brdrs\brdrw30\brsp20 ";
        PRINT #AusgabeDatei%, "\tqc\tx5000\tqr\tx10000\adjustright "
        PRINT #AusgabeDatei%, "{\field{\*\fldinst{ FILENAME }}";
        PRINT #AusgabeDatei%, "{\fldrslt{"; Ziel$; "}}}";
        PRINT #AusgabeDatei%, "{\tab \'a9 Norbert S\'fcdland\tab }"
        PRINT #AusgabeDatei%, "{Seite }";
        PRINT #AusgabeDatei%, "{\field{\*\fldinst{ PAGE }}}{ / }";
        PRINT #AusgabeDatei%, "{\field{\*\fldinst{ NUMPAGES }}}"
        PRINT #AusgabeDatei%, "{\par }}"
        PRINT #AusgabeDatei%, "{\footerl}"
        PRINT #AusgabeDatei%, "{\footerr}"
        PRINT #AusgabeDatei%, "\b\fs20"
        WHILE EOF(EingabeDatei%) = 0
          Kopie$ = "{\f0 "
          LINE INPUT #EingabeDatei%, Zeile$
          FOR Zaehler% = 1 TO LEN(Zeile$)
            Zeichen$ = MID$(Zeile$, Zaehler%, 1)
            Kodierung$ = ""
            SELECT CASE ASC(Zeichen$)
            CASE 0
              STOP      'Programmier-Fehler?    '\x00
              Kodierung$ = ""
            CASE 1
              Kodierung$ = "\u9786\'3f"         '\x01
            CASE 2
              Kodierung$ = "\u9787\'3f"         '\x02
            CASE 3
              Kodierung$ = "\u9829\'3f"         '\x03
            CASE 4
              Kodierung$ = "\u9830\'3f"         '\x04
            CASE 5
              Kodierung$ = "\u9827\'3f"         '\x05
            CASE 6
              Kodierung$ = "\u9824\'3f"         '\x06
            CASE 7
              Kodierung$ = "\u9679\'3f"         '\x07
            CASE 8
              Kodierung$ = "\u9688\'3f"         '\x08
            CASE 9
              Kodierung$ = "\u9675\'3f"         '\x09
            CASE 10
              Kodierung$ = "\u9689\'3f"         '\x0A
            CASE 11
              Kodierung$ = "\u9794\'3f"         '\x0B
            CASE 12
              Kodierung$ = "\u9792\'3f"         '\x0C
            CASE 13
              Kodierung$ = "\u9834\'3f"         '\x0D
            CASE 14
              Kodierung$ = "\u9835\'3f"         '\x0E
            CASE 15
              Kodierung$ = "\u9788\'a4"         '\x0F
            CASE 16
              Kodierung$ = "\u9658\'3f"         '\x10
            CASE 17
              Kodierung$ = "\u9668\'3f"         '\x11
            CASE 18
              Kodierung$ = "\u8597\'3f"         '\x12
            CASE 19
              Kodierung$ = "\u8252\'3f"         '\x13
            CASE 20
              Kodierung$ = "\'b6"               '\x14
            CASE 21
              Kodierung$ = "\'a7"               '\x15
            CASE 22
              Kodierung$ = "\u9644\'3f"         '\x16
            CASE 23
              Kodierung$ = "\u8616\'3f"         '\x17
            CASE 24
              Kodierung$ = "\u8578\'2b"         '\x18
            CASE 25
              Kodierung$ = "\u8595\'3f"         '\x19
            CASE 26
              Kodierung$ = "\u8594\'3f"         '\x1A
            CASE 27
              Kodierung$ = "\u8592\'3f"         '\x1B
            CASE 28
              Kodierung$ = "\u8735\'3f"         '\x1C
            CASE 29
              Kodierung$ = "\u9612\'3f"         '\x1D
            CASE 30
              Kodierung$ = "\u9650\'3f"         '\x1E
            CASE 31
              Kodierung$ = "\u9660\'3f"         '\X1F
            CASE 34
              Kodierung$ = "\u8243\'3f"         '"
            CASE 92
              Kodierung$ = "\\"                 '\
            CASE 123
              Kodierung$ = "\{"                 '{
            CASE 125
              Kodierung$ = "\}"                 '}
            CASE 126
              Kodierung$ = "\'98"               '~
            CASE 127
              Kodierung$ = "\u8962\'a6"         '\x7F
            CASE 128
              Kodierung$ = "\'c7"               '
            CASE 129
              Kodierung$ = "\'fc"               '
            CASE 130
              Kodierung$ = "\'e9"               '
            CASE 131
              Kodierung$ = "\'e2"               '
            CASE 132
              Kodierung$ = "\'e4"               '
            CASE 133
              Kodierung$ = "\'e0"               '
            CASE 134
              Kodierung$ = "\'e5"               '
            CASE 135
              Kodierung$ = "\'e7"               '
            CASE 136
              Kodierung$ = "\'ea"               '
            CASE 137
              Kodierung$ = "\'eb"               '
            CASE 138
              Kodierung$ = "\'e8"               '
            CASE 139
              Kodierung$ = "\'ef"               '
            CASE 140
              Kodierung$ = "\'ee"               '
            CASE 141
              Kodierung$ = "\'ec"               '
            CASE 142
              Kodierung$ = "\'c4"               '
            CASE 143
              Kodierung$ = "\'c5"               '
            CASE 144
              Kodierung$ = "\'c9"               '
            CASE 145
              Kodierung$ = "\'e6"               '
            CASE 146
              Kodierung$ = "\'c6"               '
            CASE 147
              Kodierung$ = "\'f4"               '
            CASE 148
              Kodierung$ = "\'f6"               '
            CASE 149
              Kodierung$ = "\'f2"               '
            CASE 150
              Kodierung$ = "\'fb"               '
            CASE 151
              Kodierung$ = "\'f9"               '
            CASE 152
              Kodierung$ = "\'ff"               '
            CASE 153
              Kodierung$ = "\'d6"               '
            CASE 154
              Kodierung$ = "\'dc"               '
            CASE 155
              Kodierung$ = "\'a2"               '
            CASE 156
              Kodierung$ = "\'a3"               '
            CASE 157
              Kodierung$ = "\'a5"               '
            CASE 158
              Kodierung$ = "\u8359\'50"         '
            CASE 159
              Kodierung$ = "\'83"               '
            CASE 160
              Kodierung$ = "\'e1"               '
            CASE 161
              Kodierung$ = "\'ed"               '
            CASE 162
              Kodierung$ = "\'f3"               '
            CASE 163
              Kodierung$ = "\'fa"               '
            CASE 164
              Kodierung$ = "\'f1"               '
            CASE 165
              Kodierung$ = "\'d1"               '
            CASE 166
              Kodierung$ = "\'aa"               '
            CASE 167
              Kodierung$ = "\'ba"               '
            CASE 168
              Kodierung$ = "\'bf"               '
            CASE 169
              Kodierung$ = "\u8976\'ac"         '
            CASE 170
              Kodierung$ = "\'ac"               '
            CASE 171
              Kodierung$ = "\'bd"               '
            CASE 172
              Kodierung$ = "\'bc"               '
            CASE 173
              Kodierung$ = "\'a1"               '
            CASE 174
              Kodierung$ = "\'ab"               '
            CASE 175
              Kodierung$ = "\'bb"               '
            CASE 176
              Kodierung$ = "\u9617\'a6"         '
            CASE 177
              Kodierung$ = "\u9618\'a6"         '
            CASE 178
              Kodierung$ = "\u9619\'a6"         '
            CASE 179
              Kodierung$ = "\u9474\'a6"         '
            CASE 180
              Kodierung$ = "\u9508\'a6"         '
            CASE 181
              Kodierung$ = "\u9569\'a6"         '
            CASE 182
              Kodierung$ = "\u9570\'a6"         '
            CASE 183
              Kodierung$ = "\u9558\'2b"         '
            CASE 184
              Kodierung$ = "\u9557\'2b"         '
            CASE 185
              Kodierung$ = "\u9571\'a6"         '
            CASE 186
              Kodierung$ = "\u9553\'a6"         '
            CASE 187
              Kodierung$ = "\u9559\'2b"         '
            CASE 188
              Kodierung$ = "\u9565\'2b"         '
            CASE 189
              Kodierung$ = "\u9564\'2b"         '
            CASE 190
              Kodierung$ = "\u9563\'2b"         '
            CASE 191
              Kodierung$ = "\u9488\'2b"         '
            CASE 192
              Kodierung$ = "\u9492\'2b"         '
            CASE 193
              Kodierung$ = "\u9524\'2d"         '
            CASE 194
              Kodierung$ = "\u9516\'2d"         '
            CASE 195
              Kodierung$ = "\u9500\'2b"         '
            CASE 196
              Kodierung$ = "\u9472\'2d"         '
            CASE 197
              Kodierung$ = "\u9532\'2b"         '
            CASE 198
              Kodierung$ = "\u9566\'a6"         '
            CASE 199
              Kodierung$ = "\u9567\'a6"         '
            CASE 200
              Kodierung$ = "\u9562\'2b"         '
            CASE 201
              Kodierung$ = "\u9556\'2b"         '
            CASE 202
              Kodierung$ = "\u9577\'2d"         '
            CASE 203
              Kodierung$ = "\u9574\'2d"         '
            CASE 204
              Kodierung$ = "\u9568\'a6"         '
            CASE 205
              Kodierung$ = "\u9552\'2d"         '
            CASE 206
              Kodierung$ = "\u9580\'2b"         '
            CASE 207
              Kodierung$ = "\u9575\'2d"         '
            CASE 208
              Kodierung$ = "\u9576\'2d"         '
            CASE 209
              Kodierung$ = "\u9572\'2d"         '
            CASE 210
              Kodierung$ = "\u9573\'2d"         '
            CASE 211
              Kodierung$ = "\u9561\'2b"         '
            CASE 212
              Kodierung$ = "\u9560\'2b"         '
            CASE 213
              Kodierung$ = "\u9554\'2b"         '
            CASE 214
              Kodierung$ = "\u9555\'2b"         '
            CASE 215
              Kodierung$ = "\u9579\'2b"         '
            CASE 216
              Kodierung$ = "\u9578\'2b"         '
            CASE 217
              Kodierung$ = "\u9496\'2b"         '
            CASE 218
              Kodierung$ = "\u9484\'2b"         '
            CASE 219
              Kodierung$ = "\u9608\'a6"         '
            CASE 220
              Kodierung$ = "\u9604\'5f"         '
            CASE 221
              Kodierung$ = "\u9612\'a6"         '
            CASE 222
              Kodierung$ = "\u9616\'a6"         '
            CASE 223
              Kodierung$ = "\u9600\'af"         '
            CASE 224
              Kodierung$ = "}{\f1 \'e1}{\f0 "   '
            CASE 225
              Kodierung$ = "\'df"               '
            CASE 226
              Kodierung$ = "}{\f1 \'c3}{\f0 "   '
            CASE 227
              Kodierung$ = "}{\f1 \'f0}{\f0 "   '
            CASE 228
              Kodierung$ = "}{\f1 \'d3}{\f0 "   '
            CASE 229
              Kodierung$ = "}{\f1 \'f3}{\f0 "   '
            CASE 230
              Kodierung$ = "\'b5"               '
            CASE 231
              Kodierung$ = "}{\f1 \'f4}{\f0 "   '
            CASE 232
              Kodierung$ = "}{\f1 \'d6}{\f0 "   '
            CASE 233
              Kodierung$ = "}{\f1 \'c8}{\f0 "   '
            CASE 234
              Kodierung$ = "}{\f1 \'d9}{\f0 "   '
            CASE 235
              Kodierung$ = "}{\f1 \'e4}{\f0 "   '
            CASE 236
              Kodierung$ = "\u8734\'38"         '
            CASE 237
              Kodierung$ = "\'f8"               '
            CASE 238
              Kodierung$ = "}{\f2 \'aa}{\f0 "   '
            CASE 239
              Kodierung$ = "\u8745\'6e"         '
            CASE 240
              Kodierung$ = "\u8801\'3d"         '
            CASE 241
              Kodierung$ = "\'b1"               '
            CASE 242
              Kodierung$ = "\u8805\'3d"         '
            CASE 243
              Kodierung$ = "\u8804\'3d"         '
            CASE 244
              Kodierung$ = "\u8992\'28"         '
            CASE 245
              Kodierung$ = "\u8993\'29"         '
            CASE 246
              Kodierung$ = "\'f7"               '
            CASE 247
              Kodierung$ = "\u8776\'98"         '
            CASE 248
              Kodierung$ = "\'b0"               '
            CASE 249
              Kodierung$ = "\bullet "           '
            CASE 250
              Kodierung$ = "\u8729\'b7"         '
            CASE 251
              Kodierung$ = "\u8730\'76"         '
            CASE 252
              Kodierung$ = "\u8319\'6e"         '
            CASE 253
              Kodierung$ = "\'b2"               '
            CASE 254
              Kodierung$ = "\u9642\'3f"         '
            CASE 255
              Kodierung$ = SPACE$(1)            '\xFF
            CASE ELSE
              Kodierung$ = Zeichen$
            END SELECT
            Kopie$ = Kopie$ + Kodierung$
          NEXT Zaehler%
          Kopie$ = Kopie$ + "}\par"
          PRINT #AusgabeDatei%, Kopie$
        WEND
        PRINT #AusgabeDatei%, "}"
      CLOSE #AusgabeDatei%
    CLOSE #EingabeDatei%
    PRINT "Die Datei "; CHR$(34); Zwischenziel$; CHR$(34); " wurde erstellt."
  END IF
END IF
SYSTEM


'=============================================================================
' Ende von "437-RTF.BAS"
'=============================================================================

